/*
 * Copyright 2021, 2024  NXP
 * All rights reserved.
 *
 * SPDX-License-Identifier: BSD-3-Clause
 */

/***********************************************************************************************************************
 * This file was generated by the MCUXpresso Config Tools. Any manual edits made to this file
 * will be overwritten if the respective MCUXpresso Config Tools is used to update this file.
 **********************************************************************************************************************/

#ifndef _PIN_MUX_H_
#define _PIN_MUX_H_

/*!
 * @addtogroup pin_mux
 * @{
 */

/***********************************************************************************************************************
 * API
 **********************************************************************************************************************/

#if defined(__cplusplus)
extern "C" {
#endif

/*!
 * @brief Calls initialization functions.
 *
 */
void BOARD_InitBootPins(void);

#define IOPCTL_PIO_ANAMUX_DI 0x00u        /*!<@brief Analog mux is disabled */
#define IOPCTL_PIO_FULLDRIVE_DI 0x00u     /*!<@brief Normal drive */
#define IOPCTL_PIO_FUNC1 0x01u            /*!<@brief Selects pin function 1 */
#define IOPCTL_PIO_INBUF_DI 0x00u         /*!<@brief Disable input buffer function */
#define IOPCTL_PIO_INBUF_EN 0x40u         /*!<@brief Enables input buffer function */
#define IOPCTL_PIO_INV_DI 0x00u           /*!<@brief Input function is not inverted */
#define IOPCTL_PIO_PSEDRAIN_DI 0x00u      /*!<@brief Pseudo Output Drain is disabled */
#define IOPCTL_PIO_PULLUP_EN 0x20u        /*!<@brief Enable pull-up function */
#define IOPCTL_PIO_PUPD_EN 0x10u          /*!<@brief Enable pull-up / pull-down function */
#define IOPCTL_PIO_SLEW_RATE_NORMAL 0x00u /*!<@brief Normal mode */

/*!
 * @brief Configures pin routing and optionally pin electrical features.
 *
 */
void BOARD_InitPins(void); /* Function assigned for the Cortex-M33 */

#define IOPCTL_PIO_ANAMUX_DI 0x00u        /*!<@brief Analog mux is disabled */
#define IOPCTL_PIO_FULLDRIVE_DI 0x00u     /*!<@brief Normal drive */
#define IOPCTL_PIO_FUNC1 0x01u            /*!<@brief Selects pin function 1 */
#define IOPCTL_PIO_INBUF_DI 0x00u         /*!<@brief Disable input buffer function */
#define IOPCTL_PIO_INBUF_EN 0x40u         /*!<@brief Enables input buffer function */
#define IOPCTL_PIO_INV_DI 0x00u           /*!<@brief Input function is not inverted */
#define IOPCTL_PIO_PSEDRAIN_DI 0x00u      /*!<@brief Pseudo Output Drain is disabled */
#define IOPCTL_PIO_PULLDOWN_EN 0x00u      /*!<@brief Enable pull-down function */
#define IOPCTL_PIO_PULLUP_EN 0x20u        /*!<@brief Enable pull-up function */
#define IOPCTL_PIO_PUPD_DI 0x00u          /*!<@brief Disable pull-up / pull-down function */
#define IOPCTL_PIO_PUPD_EN 0x10u          /*!<@brief Enable pull-up / pull-down function */
#define IOPCTL_PIO_SLEW_RATE_NORMAL 0x00u /*!<@brief Normal mode */

/*! @name SWO (coord L16), U7[12]
  @{ */
/* Routed pin properties */
#define BOARD_INITDEBUG_UARTPINS_SWO_PERIPHERAL SWD /*!<@brief Peripheral name */
#define BOARD_INITDEBUG_UARTPINS_SWO_SIGNAL SWO     /*!<@brief Signal name */
                                                    /* @} */

/*!
 * @brief Configures pin routing and optionally pin electrical features.
 *
 */
void BOARD_InitDEBUG_UARTPins(void); /* Function assigned for the Cortex-M33 */

#define IOPCTL_PIO_ANAMUX_DI 0x00u        /*!<@brief Analog mux is disabled */
#define IOPCTL_PIO_FULLDRIVE_DI 0x00u     /*!<@brief Normal drive */
#define IOPCTL_PIO_FULLDRIVE_EN 0x0100u   /*!<@brief Full drive enable */
#define IOPCTL_PIO_FUNC5 0x05u            /*!<@brief Selects pin function 5 */
#define IOPCTL_PIO_FUNC6 0x06u            /*!<@brief Selects pin function 6 */
#define IOPCTL_PIO_INBUF_EN 0x40u         /*!<@brief Enables input buffer function */
#define IOPCTL_PIO_INV_DI 0x00u           /*!<@brief Input function is not inverted */
#define IOPCTL_PIO_PSEDRAIN_DI 0x00u      /*!<@brief Pseudo Output Drain is disabled */
#define IOPCTL_PIO_PULLDOWN_EN 0x00u      /*!<@brief Enable pull-down function */
#define IOPCTL_PIO_PUPD_DI 0x00u          /*!<@brief Disable pull-up / pull-down function */
#define IOPCTL_PIO_SLEW_RATE_NORMAL 0x00u /*!<@brief Normal mode */

/*! @name FLEXSPI0B_DATA0 (coord L2), U19[D3]
  @{ */
/* Routed pin properties */
/*!
 * @brief Peripheral name */
#define BOARD_INITFLEXSPIFLASHPINS_QSPI_B_DATA0_PERIPHERAL FLEXSPI
/*!
 * @brief Signal name */
#define BOARD_INITFLEXSPIFLASHPINS_QSPI_B_DATA0_SIGNAL FLEXSPI_B_DATA0
/* @} */

/*! @name FLEXSPI0B_DATA1 (coord M2), U19[D2]
  @{ */
/* Routed pin properties */
/*!
 * @brief Peripheral name */
#define BOARD_INITFLEXSPIFLASHPINS_QSPI_B_DATA1_PERIPHERAL FLEXSPI
/*!
 * @brief Signal name */
#define BOARD_INITFLEXSPIFLASHPINS_QSPI_B_DATA1_SIGNAL FLEXSPI_B_DATA1
/* @} */

/*! @name FLEXSPI0B_DATA2 (coord N1), U19[C4]
  @{ */
/* Routed pin properties */
/*!
 * @brief Peripheral name */
#define BOARD_INITFLEXSPIFLASHPINS_QSPI_B_DATA2_PERIPHERAL FLEXSPI
/*!
 * @brief Signal name */
#define BOARD_INITFLEXSPIFLASHPINS_QSPI_B_DATA2_SIGNAL FLEXSPI_B_DATA2
/* @} */

/*! @name FLEXSPI0B_DATA3 (coord N2), U19[D4]
  @{ */
/* Routed pin properties */
/*!
 * @brief Peripheral name */
#define BOARD_INITFLEXSPIFLASHPINS_QSPI_B_DATA3_PERIPHERAL FLEXSPI
/*!
 * @brief Signal name */
#define BOARD_INITFLEXSPIFLASHPINS_QSPI_B_DATA3_SIGNAL FLEXSPI_B_DATA3
/* @} */

/*! @name FLEXSPI0B_DATA4 (coord U1), U19[D5]
  @{ */
/* Routed pin properties */
/*!
 * @brief Peripheral name */
#define BOARD_INITFLEXSPIFLASHPINS_QSPI_B_DATA4_PERIPHERAL FLEXSPI
/*!
 * @brief Signal name */
#define BOARD_INITFLEXSPIFLASHPINS_QSPI_B_DATA4_SIGNAL FLEXSPI_B_DATA4
/* @} */

/*! @name FLEXSPI0B_DATA5 (coord R2), U19[E3]
  @{ */
/* Routed pin properties */
/*!
 * @brief Peripheral name */
#define BOARD_INITFLEXSPIFLASHPINS_QSPI_B_DATA5_PERIPHERAL FLEXSPI
/*!
 * @brief Signal name */
#define BOARD_INITFLEXSPIFLASHPINS_QSPI_B_DATA5_SIGNAL FLEXSPI_B_DATA5
/* @} */

/*! @name FLEXSPI0B_DATA6 (coord P3), U19[E2]
  @{ */
/* Routed pin properties */
/*!
 * @brief Peripheral name */
#define BOARD_INITFLEXSPIFLASHPINS_QSPI_B_DATA6_PERIPHERAL FLEXSPI
/*!
 * @brief Signal name */
#define BOARD_INITFLEXSPIFLASHPINS_QSPI_B_DATA6_SIGNAL FLEXSPI_B_DATA6
/* @} */

/*! @name FLEXSPI0B_DATA7 (coord P5), U19[E1]
  @{ */
/* Routed pin properties */
/*!
 * @brief Peripheral name */
#define BOARD_INITFLEXSPIFLASHPINS_QSPI_B_DATA7_PERIPHERAL FLEXSPI
/*!
 * @brief Signal name */
#define BOARD_INITFLEXSPIFLASHPINS_QSPI_B_DATA7_SIGNAL FLEXSPI_B_DATA7
/* @} */

/*! @name FLEXSPI0B_SS0_N (coord T2), U19[C2]
  @{ */
/* Routed pin properties */
#define BOARD_INITFLEXSPIFLASHPINS_QSPI_B_CS0_PERIPHERAL FLEXSPI       /*!<@brief Peripheral name */
#define BOARD_INITFLEXSPIFLASHPINS_QSPI_B_CS0_SIGNAL FLEXSPI_B_SS0_B   /*!<@brief Signal name */
                                                                       /* @} */

/*! @name FLEXSPI0B_SCLK (coord U3), U19[B2]
  @{ */
/* Routed pin properties */
#define BOARD_INITFLEXSPIFLASHPINS_QSPI_B_SCK_PERIPHERAL FLEXSPI      /*!<@brief Peripheral name */
#define BOARD_INITFLEXSPIFLASHPINS_QSPI_B_SCK_SIGNAL FLEXSPI_B_SCLK   /*!<@brief Signal name */
                                                                      /* @} */

/*!
 * @brief Configures pin routing and optionally pin electrical features.
 *
 */
void BOARD_InitFlexSPIFlashPins(void); /* Function assigned for the Cortex-M33 */

#define IOPCTL_PIO_ANAMUX_DI 0x00u        /*!<@brief Analog mux is disabled */
#define IOPCTL_PIO_FULLDRIVE_DI 0x00u     /*!<@brief Normal drive */
#define IOPCTL_PIO_FULLDRIVE_EN 0x0100u   /*!<@brief Full drive enable */
#define IOPCTL_PIO_FUNC1 0x01u            /*!<@brief Selects pin function 1 */
#define IOPCTL_PIO_INBUF_DI 0x00u         /*!<@brief Disable input buffer function */
#define IOPCTL_PIO_INBUF_EN 0x40u         /*!<@brief Enables input buffer function */
#define IOPCTL_PIO_INV_DI 0x00u           /*!<@brief Input function is not inverted */
#define IOPCTL_PIO_PSEDRAIN_DI 0x00u      /*!<@brief Pseudo Output Drain is disabled */
#define IOPCTL_PIO_PULLDOWN_EN 0x00u      /*!<@brief Enable pull-down function */
#define IOPCTL_PIO_PUPD_DI 0x00u          /*!<@brief Disable pull-up / pull-down function */
#define IOPCTL_PIO_SLEW_RATE_NORMAL 0x00u /*!<@brief Normal mode */

/*! @name FLEXSPI0A_DATA0 (coord T5), U108[D3]
  @{ */
/* Routed pin properties */
#define BOARD_INITPSRAMPINS_PSRAM_ADQ0_PERIPHERAL FLEXSPI       /*!<@brief Peripheral name */
#define BOARD_INITPSRAMPINS_PSRAM_ADQ0_SIGNAL FLEXSPI_A_DATA0   /*!<@brief Signal name */
                                                                /* @} */

/*! @name FLEXSPI0A_DATA1 (coord U5), U108[D2]
  @{ */
/* Routed pin properties */
#define BOARD_INITPSRAMPINS_PSRAM_ADQ1_PERIPHERAL FLEXSPI       /*!<@brief Peripheral name */
#define BOARD_INITPSRAMPINS_PSRAM_ADQ1_SIGNAL FLEXSPI_A_DATA1   /*!<@brief Signal name */
                                                                /* @} */

/*! @name FLEXSPI0A_DATA2 (coord P6), U108[C4]
  @{ */
/* Routed pin properties */
#define BOARD_INITPSRAMPINS_PSRAM_ADQ2_PERIPHERAL FLEXSPI       /*!<@brief Peripheral name */
#define BOARD_INITPSRAMPINS_PSRAM_ADQ2_SIGNAL FLEXSPI_A_DATA2   /*!<@brief Signal name */
                                                                /* @} */

/*! @name FLEXSPI0A_DATA3 (coord P7), U108[D4]
  @{ */
/* Routed pin properties */
#define BOARD_INITPSRAMPINS_PSRAM_ADQ3_PERIPHERAL FLEXSPI       /*!<@brief Peripheral name */
#define BOARD_INITPSRAMPINS_PSRAM_ADQ3_SIGNAL FLEXSPI_A_DATA3   /*!<@brief Signal name */
                                                                /* @} */

/*! @name FLEXSPI0A_DATA4 (coord T7), U108[D5]
  @{ */
/* Routed pin properties */
#define BOARD_INITPSRAMPINS_PSRAM_ADQ4_PERIPHERAL FLEXSPI       /*!<@brief Peripheral name */
#define BOARD_INITPSRAMPINS_PSRAM_ADQ4_SIGNAL FLEXSPI_A_DATA4   /*!<@brief Signal name */
                                                                /* @} */

/*! @name FLEXSPI0A_DATA5 (coord U7), U108[E3]
  @{ */
/* Routed pin properties */
#define BOARD_INITPSRAMPINS_PSRAM_ADQ5_PERIPHERAL FLEXSPI       /*!<@brief Peripheral name */
#define BOARD_INITPSRAMPINS_PSRAM_ADQ5_SIGNAL FLEXSPI_A_DATA5   /*!<@brief Signal name */
                                                                /* @} */

/*! @name FLEXSPI0A_DATA6 (coord R7), U108[E2]
  @{ */
/* Routed pin properties */
#define BOARD_INITPSRAMPINS_PSRAM_ADQ6_PERIPHERAL FLEXSPI       /*!<@brief Peripheral name */
#define BOARD_INITPSRAMPINS_PSRAM_ADQ6_SIGNAL FLEXSPI_A_DATA6   /*!<@brief Signal name */
                                                                /* @} */

/*! @name FLEXSPI0A_DATA7 (coord T8), U108[E1]
  @{ */
/* Routed pin properties */
#define BOARD_INITPSRAMPINS_PSRAM_ADQ7_PERIPHERAL FLEXSPI       /*!<@brief Peripheral name */
#define BOARD_INITPSRAMPINS_PSRAM_ADQ7_SIGNAL FLEXSPI_A_DATA7   /*!<@brief Signal name */
                                                                /* @} */

/*! @name FLEXSPI0A_DQS (coord U9), U108[C3]
  @{ */
/* Routed pin properties */
#define BOARD_INITPSRAMPINS_PSRAM_DQS_PERIPHERAL FLEXSPI     /*!<@brief Peripheral name */
#define BOARD_INITPSRAMPINS_PSRAM_DQS_SIGNAL FLEXSPI_A_DQS   /*!<@brief Signal name */
                                                             /* @} */

/*! @name FLEXSPI0A_SCLK (coord T9), U108[B2]
  @{ */
/* Routed pin properties */
#define BOARD_INITPSRAMPINS_PSRAM_CLK_PERIPHERAL FLEXSPI      /*!<@brief Peripheral name */
#define BOARD_INITPSRAMPINS_PSRAM_CLK_SIGNAL FLEXSPI_A_SCLK   /*!<@brief Signal name */
                                                              /* @} */

/*! @name FLEXSPI0A_SS0_N (coord T4), U108[A3]
  @{ */
/* Routed pin properties */
#define BOARD_INITPSRAMPINS_PSRAM_CE_PERIPHERAL FLEXSPI       /*!<@brief Peripheral name */
#define BOARD_INITPSRAMPINS_PSRAM_CE_SIGNAL FLEXSPI_A_SS0_B   /*!<@brief Signal name */
                                                              /* @} */

/*!
 * @brief Configures pin routing and optionally pin electrical features.
 *
 */
void BOARD_InitPSRAMPins(void); /* Function assigned for the Cortex-M33 */

#define IOPCTL_PIO_ANAMUX_DI 0x00u        /*!<@brief Analog mux is disabled */
#define IOPCTL_PIO_FULLDRIVE_DI 0x00u     /*!<@brief Normal drive */
#define IOPCTL_PIO_FUNC0 0x00u            /*!<@brief Selects pin function 0 */
#define IOPCTL_PIO_FUNC1 0x01u            /*!<@brief Selects pin function 1 */
#define IOPCTL_PIO_INBUF_DI 0x00u         /*!<@brief Disable input buffer function */
#define IOPCTL_PIO_INBUF_EN 0x40u         /*!<@brief Enables input buffer function */
#define IOPCTL_PIO_INV_DI 0x00u           /*!<@brief Input function is not inverted */
#define IOPCTL_PIO_PSEDRAIN_DI 0x00u      /*!<@brief Pseudo Output Drain is disabled */
#define IOPCTL_PIO_PULLDOWN_EN 0x00u      /*!<@brief Enable pull-down function */
#define IOPCTL_PIO_PULLUP_EN 0x20u        /*!<@brief Enable pull-up function */
#define IOPCTL_PIO_PUPD_DI 0x00u          /*!<@brief Disable pull-up / pull-down function */
#define IOPCTL_PIO_PUPD_EN 0x10u          /*!<@brief Enable pull-up / pull-down function */
#define IOPCTL_PIO_SLEW_RATE_NORMAL 0x00u /*!<@brief Normal mode */

/*! @name SD0_D0 (coord R11), J32[7]/SD_DAT0
  @{ */
/* Routed pin properties */
#define BOARD_INITUSDHC0PINS_SD_DAT0_PERIPHERAL USDHC0      /*!<@brief Peripheral name */
#define BOARD_INITUSDHC0PINS_SD_DAT0_SIGNAL USDHC_DATA      /*!<@brief Signal name */
#define BOARD_INITUSDHC0PINS_SD_DAT0_CHANNEL 0              /*!<@brief Signal channel */
                                                            /* @} */

/*! @name SD0_D1 (coord T11), J32[8]/SD_DAT1
  @{ */
/* Routed pin properties */
#define BOARD_INITUSDHC0PINS_SD_DAT1_PERIPHERAL USDHC0      /*!<@brief Peripheral name */
#define BOARD_INITUSDHC0PINS_SD_DAT1_SIGNAL USDHC_DATA      /*!<@brief Signal name */
#define BOARD_INITUSDHC0PINS_SD_DAT1_CHANNEL 1              /*!<@brief Signal channel */
                                                            /* @} */

/*! @name SD0_D2 (coord U11), J32[9]/SD_DAT2
  @{ */
/* Routed pin properties */
#define BOARD_INITUSDHC0PINS_SD_DAT2_PERIPHERAL USDHC0      /*!<@brief Peripheral name */
#define BOARD_INITUSDHC0PINS_SD_DAT2_SIGNAL USDHC_DATA      /*!<@brief Signal name */
#define BOARD_INITUSDHC0PINS_SD_DAT2_CHANNEL 2              /*!<@brief Signal channel */
                                                            /* @} */

/*! @name SD0_D3 (coord T12), J32[1]/SD_DAT3
  @{ */
/* Routed pin properties */
#define BOARD_INITUSDHC0PINS_SD_DAT3_PERIPHERAL USDHC0      /*!<@brief Peripheral name */
#define BOARD_INITUSDHC0PINS_SD_DAT3_SIGNAL USDHC_DATA      /*!<@brief Signal name */
#define BOARD_INITUSDHC0PINS_SD_DAT3_CHANNEL 3              /*!<@brief Signal channel */
                                                            /* @} */

/*! @name SD0_CLK (coord P10), J32[5]/SD_CLK
  @{ */
/* Routed pin properties */
#define BOARD_INITUSDHC0PINS_SD_CLK_PERIPHERAL USDHC0     /*!<@brief Peripheral name */
#define BOARD_INITUSDHC0PINS_SD_CLK_SIGNAL USDHC_CLK      /*!<@brief Signal name */
                                                          /* @} */

/*! @name SD0_CMD (coord R9), J32[2]/SD_CMD
  @{ */
/* Routed pin properties */
#define BOARD_INITUSDHC0PINS_SD_CMD_PERIPHERAL USDHC0     /*!<@brief Peripheral name */
#define BOARD_INITUSDHC0PINS_SD_CMD_SIGNAL USDHC_CMD      /*!<@brief Signal name */
                                                          /* @} */

/*! @name SD0_CARD_DET_N (coord R13), J32[10]/CARD_CD/SD_CD
  @{ */
/* Routed pin properties */
#define BOARD_INITUSDHC0PINS_SD_CD_PERIPHERAL USDHC0             /*!<@brief Peripheral name */
#define BOARD_INITUSDHC0PINS_SD_CD_SIGNAL USDHC_CD_B             /*!<@brief Signal name */
                                                                 /* @} */

/*! @name PIO2_10 (coord T15), U23[3]/SD_RST_N
  @{ */
/* Routed pin properties */
#define BOARD_INITUSDHC0PINS_SD_RST_N_PERIPHERAL GPIO           /*!<@brief Peripheral name */
#define BOARD_INITUSDHC0PINS_SD_RST_N_SIGNAL PIO2               /*!<@brief Signal name */
#define BOARD_INITUSDHC0PINS_SD_RST_N_CHANNEL 10                /*!<@brief Signal channel */

/* Symbols to be used with GPIO driver */
#define BOARD_INITUSDHC0PINS_SD_RST_N_GPIO GPIO                 /*!<@brief GPIO peripheral base pointer */
#define BOARD_INITUSDHC0PINS_SD_RST_N_GPIO_PIN_MASK (1U << 10U) /*!<@brief GPIO pin mask */
#define BOARD_INITUSDHC0PINS_SD_RST_N_PORT 2U                   /*!<@brief PORT peripheral base pointer */
#define BOARD_INITUSDHC0PINS_SD_RST_N_PIN 10U                   /*!<@brief PORT pin number */
#define BOARD_INITUSDHC0PINS_SD_RST_N_PIN_MASK (1U << 10U)      /*!<@brief PORT pin mask */
                                                                /* @} */

/*!
 * @brief Configures pin routing and optionally pin electrical features.
 *
 */
void BOARD_InitUSDHC0Pins(void); /* Function assigned for the Cortex-M33 */

#define IOPCTL_PIO_ANAMUX_DI 0x00u        /*!<@brief Analog mux is disabled */
#define IOPCTL_PIO_FULLDRIVE_DI 0x00u     /*!<@brief Normal drive */
#define IOPCTL_PIO_FUNC0 0x00u            /*!<@brief Selects pin function 0 */
#define IOPCTL_PIO_INBUF_DI 0x00u         /*!<@brief Disable input buffer function */
#define IOPCTL_PIO_INV_DI 0x00u           /*!<@brief Input function is not inverted */
#define IOPCTL_PIO_PSEDRAIN_DI 0x00u      /*!<@brief Pseudo Output Drain is disabled */
#define IOPCTL_PIO_PULLDOWN_EN 0x00u      /*!<@brief Enable pull-down function */
#define IOPCTL_PIO_PUPD_DI 0x00u          /*!<@brief Disable pull-up / pull-down function */
#define IOPCTL_PIO_SLEW_RATE_NORMAL 0x00u /*!<@brief Normal mode */

/*! @name PIO0_14 (coord A3), Q4[5]
  @{ */
/* Routed pin properties */
/*!
 * @brief Peripheral name */
#define BOARD_INITLEDSPINS_LED_GREEN_PERIPHERAL GPIO
/*!
 * @brief Signal name */
#define BOARD_INITLEDSPINS_LED_GREEN_SIGNAL PIO0
/*!
 * @brief Signal channel */
#define BOARD_INITLEDSPINS_LED_GREEN_CHANNEL 14

/* Symbols to be used with GPIO driver */
/*!
 * @brief GPIO peripheral base pointer */
#define BOARD_INITLEDSPINS_LED_GREEN_GPIO GPIO
/*!
 * @brief GPIO pin mask */
#define BOARD_INITLEDSPINS_LED_GREEN_GPIO_PIN_MASK (1U << 14U)
/*!
 * @brief PORT peripheral base pointer */
#define BOARD_INITLEDSPINS_LED_GREEN_PORT 0U
/*!
 * @brief PORT pin number */
#define BOARD_INITLEDSPINS_LED_GREEN_PIN 14U
/*!
 * @brief PORT pin mask */
#define BOARD_INITLEDSPINS_LED_GREEN_PIN_MASK (1U << 14U)
/* @} */

/*! @name PIO0_26 (coord A2), Q3[2]
  @{ */
/* Routed pin properties */
#define BOARD_INITLEDSPINS_LED_BLUE_PERIPHERAL GPIO                    /*!<@brief Peripheral name */
#define BOARD_INITLEDSPINS_LED_BLUE_SIGNAL PIO0                        /*!<@brief Signal name */
#define BOARD_INITLEDSPINS_LED_BLUE_CHANNEL 26                         /*!<@brief Signal channel */

/* Symbols to be used with GPIO driver */
#define BOARD_INITLEDSPINS_LED_BLUE_GPIO GPIO                          /*!<@brief GPIO peripheral base pointer */
#define BOARD_INITLEDSPINS_LED_BLUE_GPIO_PIN_MASK (1U << 26U)          /*!<@brief GPIO pin mask */
#define BOARD_INITLEDSPINS_LED_BLUE_PORT 0U                            /*!<@brief PORT peripheral base pointer */
#define BOARD_INITLEDSPINS_LED_BLUE_PIN 26U                            /*!<@brief PORT pin number */
#define BOARD_INITLEDSPINS_LED_BLUE_PIN_MASK (1U << 26U)               /*!<@brief PORT pin mask */
                                                                       /* @} */

/*! @name PIO0_31 (coord A11), Q4[2]
  @{ */
/* Routed pin properties */
#define BOARD_INITLEDSPINS_LED_RED_PERIPHERAL GPIO                    /*!<@brief Peripheral name */
#define BOARD_INITLEDSPINS_LED_RED_SIGNAL PIO0                        /*!<@brief Signal name */
#define BOARD_INITLEDSPINS_LED_RED_CHANNEL 31                         /*!<@brief Signal channel */

/* Symbols to be used with GPIO driver */
#define BOARD_INITLEDSPINS_LED_RED_GPIO GPIO                          /*!<@brief GPIO peripheral base pointer */
#define BOARD_INITLEDSPINS_LED_RED_GPIO_PIN_MASK (1U << 31U)          /*!<@brief GPIO pin mask */
#define BOARD_INITLEDSPINS_LED_RED_PORT 0U                            /*!<@brief PORT peripheral base pointer */
#define BOARD_INITLEDSPINS_LED_RED_PIN 31U                            /*!<@brief PORT pin number */
#define BOARD_INITLEDSPINS_LED_RED_PIN_MASK (1U << 31U)               /*!<@brief PORT pin mask */
                                                                      /* @} */

/*!
 * @brief Configures pin routing and optionally pin electrical features.
 *
 */
void BOARD_InitLEDsPins(void); /* Function assigned for the Cortex-M33 */

#define IOPCTL_PIO_ANAMUX_DI 0x00u        /*!<@brief Analog mux is disabled */
#define IOPCTL_PIO_FULLDRIVE_DI 0x00u     /*!<@brief Normal drive */
#define IOPCTL_PIO_FUNC0 0x00u            /*!<@brief Selects pin function 0 */
#define IOPCTL_PIO_INBUF_EN 0x40u         /*!<@brief Enables input buffer function */
#define IOPCTL_PIO_INV_DI 0x00u           /*!<@brief Input function is not inverted */
#define IOPCTL_PIO_PSEDRAIN_DI 0x00u      /*!<@brief Pseudo Output Drain is disabled */
#define IOPCTL_PIO_PULLDOWN_EN 0x00u      /*!<@brief Enable pull-down function */
#define IOPCTL_PIO_PUPD_DI 0x00u          /*!<@brief Disable pull-up / pull-down function */
#define IOPCTL_PIO_SLEW_RATE_NORMAL 0x00u /*!<@brief Normal mode */

/*! @name PIO0_10 (coord J3), SW2
  @{ */
/* Routed pin properties */
#define BOARD_INITBUTTONSPINS_SW2_PERIPHERAL GPIO                   /*!<@brief Peripheral name */
#define BOARD_INITBUTTONSPINS_SW2_SIGNAL PIO0                       /*!<@brief Signal name */
#define BOARD_INITBUTTONSPINS_SW2_CHANNEL 10                        /*!<@brief Signal channel */

/* Symbols to be used with GPIO driver */
#define BOARD_INITBUTTONSPINS_SW2_GPIO GPIO                         /*!<@brief GPIO peripheral base pointer */
#define BOARD_INITBUTTONSPINS_SW2_GPIO_PIN_MASK (1U << 10U)         /*!<@brief GPIO pin mask */
#define BOARD_INITBUTTONSPINS_SW2_PORT 0U                           /*!<@brief PORT peripheral base pointer */
#define BOARD_INITBUTTONSPINS_SW2_PIN 10U                           /*!<@brief PORT pin number */
#define BOARD_INITBUTTONSPINS_SW2_PIN_MASK (1U << 10U)              /*!<@brief PORT pin mask */
                                                                    /* @} */

/*! @name PIO1_1 (coord G15), SW1
  @{ */
/* Routed pin properties */
#define BOARD_INITBUTTONSPINS_SW1_PERIPHERAL GPIO                   /*!<@brief Peripheral name */
#define BOARD_INITBUTTONSPINS_SW1_SIGNAL PIO1                       /*!<@brief Signal name */
#define BOARD_INITBUTTONSPINS_SW1_CHANNEL 1                         /*!<@brief Signal channel */

/* Symbols to be used with GPIO driver */
#define BOARD_INITBUTTONSPINS_SW1_GPIO GPIO                         /*!<@brief GPIO peripheral base pointer */
#define BOARD_INITBUTTONSPINS_SW1_GPIO_PIN_MASK (1U << 1U)          /*!<@brief GPIO pin mask */
#define BOARD_INITBUTTONSPINS_SW1_PORT 1U                           /*!<@brief PORT peripheral base pointer */
#define BOARD_INITBUTTONSPINS_SW1_PIN 1U                            /*!<@brief PORT pin number */
#define BOARD_INITBUTTONSPINS_SW1_PIN_MASK (1U << 1U)               /*!<@brief PORT pin mask */
                                                                    /* @} */

/*! @name RESETN (coord B15), JP16[3]/JP14[2]
  @{ */
/* Routed pin properties */
#define BOARD_INITBUTTONSPINS_nRESET_TRGT_PERIPHERAL SYSCON       /*!<@brief Peripheral name */
#define BOARD_INITBUTTONSPINS_nRESET_TRGT_SIGNAL RESET            /*!<@brief Signal name */
                                                                  /* @} */

/*!
 * @brief Configures pin routing and optionally pin electrical features.
 *
 */
void BOARD_InitBUTTONsPins(void); /* Function assigned for the Cortex-M33 */

#define IOPCTL_PIO_ANAMUX_DI 0x00u        /*!<@brief Analog mux is disabled */
#define IOPCTL_PIO_FULLDRIVE_DI 0x00u     /*!<@brief Normal drive */
#define IOPCTL_PIO_FULLDRIVE_EN 0x0100u   /*!<@brief Full drive enable */
#define IOPCTL_PIO_FUNC0 0x00u            /*!<@brief Selects pin function 0 */
#define IOPCTL_PIO_FUNC1 0x01u            /*!<@brief Selects pin function 1 */
#define IOPCTL_PIO_INBUF_DI 0x00u         /*!<@brief Disable input buffer function */
#define IOPCTL_PIO_INBUF_EN 0x40u         /*!<@brief Enables input buffer function */
#define IOPCTL_PIO_INV_DI 0x00u           /*!<@brief Input function is not inverted */
#define IOPCTL_PIO_PSEDRAIN_DI 0x00u      /*!<@brief Pseudo Output Drain is disabled */
#define IOPCTL_PIO_PSEDRAIN_EN 0x0400u    /*!<@brief Pseudo Output Drain is enabled */
#define IOPCTL_PIO_PULLDOWN_EN 0x00u      /*!<@brief Enable pull-down function */
#define IOPCTL_PIO_PULLUP_EN 0x20u        /*!<@brief Enable pull-up function */
#define IOPCTL_PIO_PUPD_DI 0x00u          /*!<@brief Disable pull-up / pull-down function */
#define IOPCTL_PIO_PUPD_EN 0x10u          /*!<@brief Enable pull-up / pull-down function */
#define IOPCTL_PIO_SLEW_RATE_NORMAL 0x00u /*!<@brief Normal mode */

/*! @name FC2_RTS_SCL_SSEL1 (coord B7), J28[10]/J30[6]/U6[4]
  @{ */
/* Routed pin properties */
#define BOARD_INITACCELPINS_FC2_I2C_SCL_PERIPHERAL FLEXCOMM2         /*!<@brief Peripheral name */
#define BOARD_INITACCELPINS_FC2_I2C_SCL_SIGNAL RTS_SCL_SSEL1         /*!<@brief Signal name */
                                                                     /* @} */

/*! @name FC2_CTS_SDA_SSEL0 (coord D7), J28[9]/J30[5]/J47[8]/U6[6]
  @{ */
/* Routed pin properties */
/*!
 * @brief Peripheral name */
#define BOARD_INITACCELPINS_FC2_I2C_SDA_PERIPHERAL FLEXCOMM2
/*!
 * @brief Signal name */
#define BOARD_INITACCELPINS_FC2_I2C_SDA_SIGNAL CTS_SDA_SSEL0
/* @} */

/*! @name PIO1_5 (coord J16), J28[4]/JP30[1]/J45[22]
  @{ */
/* Routed pin properties */
#define BOARD_INITACCELPINS_ACC_INT_PERIPHERAL GPIO                   /*!<@brief Peripheral name */
#define BOARD_INITACCELPINS_ACC_INT_SIGNAL PIO1                       /*!<@brief Signal name */
#define BOARD_INITACCELPINS_ACC_INT_CHANNEL 5                         /*!<@brief Signal channel */

/* Symbols to be used with GPIO driver */
#define BOARD_INITACCELPINS_ACC_INT_GPIO GPIO                         /*!<@brief GPIO peripheral base pointer */
#define BOARD_INITACCELPINS_ACC_INT_GPIO_PIN_MASK (1U << 5U)          /*!<@brief GPIO pin mask */
#define BOARD_INITACCELPINS_ACC_INT_PORT 1U                           /*!<@brief PORT peripheral base pointer */
#define BOARD_INITACCELPINS_ACC_INT_PIN 5U                            /*!<@brief PORT pin number */
#define BOARD_INITACCELPINS_ACC_INT_PIN_MASK (1U << 5U)               /*!<@brief PORT pin mask */
                                                                      /* @} */

/*! @name PIO1_7 (coord J15), J28[2]/J45[36]
  @{ */
/* Routed pin properties */
/*!
 * @brief Peripheral name */
#define BOARD_INITACCELPINS_ACC_RESET_PERIPHERAL GPIO
/*!
 * @brief Signal name */
#define BOARD_INITACCELPINS_ACC_RESET_SIGNAL PIO1
/*!
 * @brief Signal channel */
#define BOARD_INITACCELPINS_ACC_RESET_CHANNEL 7

/* Symbols to be used with GPIO driver */
/*!
 * @brief GPIO peripheral base pointer */
#define BOARD_INITACCELPINS_ACC_RESET_GPIO GPIO
/*!
 * @brief GPIO pin mask */
#define BOARD_INITACCELPINS_ACC_RESET_GPIO_PIN_MASK (1U << 7U)
/*!
 * @brief PORT peripheral base pointer */
#define BOARD_INITACCELPINS_ACC_RESET_PORT 1U
/*!
 * @brief PORT pin number */
#define BOARD_INITACCELPINS_ACC_RESET_PIN 7U
/*!
 * @brief PORT pin mask */
#define BOARD_INITACCELPINS_ACC_RESET_PIN_MASK (1U << 7U)
/* @} */

/*!
 * @brief Configures pin routing and optionally pin electrical features.
 *
 */
void BOARD_InitACCELPins(void); /* Function assigned for the Cortex-M33 */

#define IOPCTL_PIO_ANAMUX_DI 0x00u      /*!<@brief Analog mux is disabled */
#define IOPCTL_PIO_FULLDRIVE_DI 0x00u   /*!<@brief Normal drive */
#define IOPCTL_PIO_FUNC0 0x00u          /*!<@brief Selects pin function 0 */
#define IOPCTL_PIO_INBUF_EN 0x40u       /*!<@brief Enables input buffer function */
#define IOPCTL_PIO_INV_DI 0x00u         /*!<@brief Input function is not inverted */
#define IOPCTL_PIO_PSEDRAIN_DI 0x00u    /*!<@brief Pseudo Output Drain is disabled */
#define IOPCTL_PIO_PULLUP_EN 0x20u      /*!<@brief Enable pull-up function */
#define IOPCTL_PIO_PUPD_EN 0x10u        /*!<@brief Enable pull-up / pull-down function */
#define IOPCTL_PIO_SLEW_RATE_SLOW 0x80u /*!<@brief Slow mode */

/*! @name PIO2_30 (coord P16), J18[2]/U8[3]/U17[B6]/SDA_CODEC
  @{ */
/* Routed pin properties */
/*!
 * @brief Peripheral name */
#define BOARD_INITI3CPINSASGPIO_I3C0_SDA_PERIPHERAL GPIO
/*!
 * @brief Signal name */
#define BOARD_INITI3CPINSASGPIO_I3C0_SDA_SIGNAL PIO2
/*!
 * @brief Signal channel */
#define BOARD_INITI3CPINSASGPIO_I3C0_SDA_CHANNEL 30

/* Symbols to be used with GPIO driver */
/*!
 * @brief GPIO peripheral base pointer */
#define BOARD_INITI3CPINSASGPIO_I3C0_SDA_GPIO GPIO
/*!
 * @brief GPIO pin mask */
#define BOARD_INITI3CPINSASGPIO_I3C0_SDA_GPIO_PIN_MASK (1U << 30U)
/*!
 * @brief PORT peripheral base pointer */
#define BOARD_INITI3CPINSASGPIO_I3C0_SDA_PORT 2U
/*!
 * @brief PORT pin number */
#define BOARD_INITI3CPINSASGPIO_I3C0_SDA_PIN 30U
/*!
 * @brief PORT pin mask */
#define BOARD_INITI3CPINSASGPIO_I3C0_SDA_PIN_MASK (1U << 30U)
/* @} */

/*! @name PIO2_29 (coord N17), J18[1]/U8[2]/U17[A6]/SCL_CODEC
  @{ */
/* Routed pin properties */
/*!
 * @brief Peripheral name */
#define BOARD_INITI3CPINSASGPIO_I3C0_SCL_PERIPHERAL GPIO
/*!
 * @brief Signal name */
#define BOARD_INITI3CPINSASGPIO_I3C0_SCL_SIGNAL PIO2
/*!
 * @brief Signal channel */
#define BOARD_INITI3CPINSASGPIO_I3C0_SCL_CHANNEL 29

/* Symbols to be used with GPIO driver */
/*!
 * @brief GPIO peripheral base pointer */
#define BOARD_INITI3CPINSASGPIO_I3C0_SCL_GPIO GPIO
/*!
 * @brief GPIO pin mask */
#define BOARD_INITI3CPINSASGPIO_I3C0_SCL_GPIO_PIN_MASK (1U << 29U)
/*!
 * @brief PORT peripheral base pointer */
#define BOARD_INITI3CPINSASGPIO_I3C0_SCL_PORT 2U
/*!
 * @brief PORT pin number */
#define BOARD_INITI3CPINSASGPIO_I3C0_SCL_PIN 29U
/*!
 * @brief PORT pin mask */
#define BOARD_INITI3CPINSASGPIO_I3C0_SCL_PIN_MASK (1U << 29U)
/* @} */

/*!
 * @brief Configures pin routing and optionally pin electrical features.
 *
 */
void BOARD_InitI3CPinsAsGPIO(void); /* Function assigned for the Cortex-M33 */

#define IOPCTL_PIO_ANAMUX_DI 0x00u      /*!<@brief Analog mux is disabled */
#define IOPCTL_PIO_FULLDRIVE_DI 0x00u   /*!<@brief Normal drive */
#define IOPCTL_PIO_FUNC1 0x01u          /*!<@brief Selects pin function 1 */
#define IOPCTL_PIO_INBUF_DI 0x00u       /*!<@brief Disable input buffer function */
#define IOPCTL_PIO_INBUF_EN 0x40u       /*!<@brief Enables input buffer function */
#define IOPCTL_PIO_INV_DI 0x00u         /*!<@brief Input function is not inverted */
#define IOPCTL_PIO_PSEDRAIN_DI 0x00u    /*!<@brief Pseudo Output Drain is disabled */
#define IOPCTL_PIO_PULLDOWN_EN 0x00u    /*!<@brief Enable pull-down function */
#define IOPCTL_PIO_PULLUP_EN 0x20u      /*!<@brief Enable pull-up function */
#define IOPCTL_PIO_PUPD_DI 0x00u        /*!<@brief Disable pull-up / pull-down function */
#define IOPCTL_PIO_PUPD_EN 0x10u        /*!<@brief Enable pull-up / pull-down function */
#define IOPCTL_PIO_SLEW_RATE_SLOW 0x80u /*!<@brief Slow mode */

/*! @name I3C0_PUR (coord B6), J18[3]
  @{ */
/* Routed pin properties */
#define BOARD_INITI3CPINS_I3C0_PUR_PERIPHERAL I3C    /*!<@brief Peripheral name */
#define BOARD_INITI3CPINS_I3C0_PUR_SIGNAL PUR        /*!<@brief Signal name */
                                                     /* @} */

/*! @name I3C0_SCL (coord N17), J18[1]/U8[2]/U17[A6]/SCL_CODEC
  @{ */
/* Routed pin properties */
/*!
 * @brief Peripheral name */
#define BOARD_INITI3CPINS_I3C0_SCL_PERIPHERAL I3C
/*!
 * @brief Signal name */
#define BOARD_INITI3CPINS_I3C0_SCL_SIGNAL SCL
/* @} */

/*! @name I3C0_SDA (coord P16), J18[2]/U8[3]/U17[B6]/SDA_CODEC
  @{ */
/* Routed pin properties */
/*!
 * @brief Peripheral name */
#define BOARD_INITI3CPINS_I3C0_SDA_PERIPHERAL I3C
/*!
 * @brief Signal name */
#define BOARD_INITI3CPINS_I3C0_SDA_SIGNAL SDA
/* @} */

/*!
 * @brief Configures pin routing and optionally pin electrical features.
 *
 */
void BOARD_InitI3CPins(void); /* Function assigned for the Cortex-M33 */

#define IOPCTL_PIO_ANAMUX_DI 0x00u        /*!<@brief Analog mux is disabled */
#define IOPCTL_PIO_FULLDRIVE_DI 0x00u     /*!<@brief Normal drive */
#define IOPCTL_PIO_FUNC0 0x00u            /*!<@brief Selects pin function 0 */
#define IOPCTL_PIO_FUNC1 0x01u            /*!<@brief Selects pin function 1 */
#define IOPCTL_PIO_INBUF_DI 0x00u         /*!<@brief Disable input buffer function */
#define IOPCTL_PIO_INBUF_EN 0x40u         /*!<@brief Enables input buffer function */
#define IOPCTL_PIO_INV_DI 0x00u           /*!<@brief Input function is not inverted */
#define IOPCTL_PIO_PSEDRAIN_DI 0x00u      /*!<@brief Pseudo Output Drain is disabled */
#define IOPCTL_PIO_PSEDRAIN_EN 0x0400u    /*!<@brief Pseudo Output Drain is enabled */
#define IOPCTL_PIO_PULLDOWN_EN 0x00u      /*!<@brief Enable pull-down function */
#define IOPCTL_PIO_PULLUP_EN 0x20u        /*!<@brief Enable pull-up function */
#define IOPCTL_PIO_PUPD_DI 0x00u          /*!<@brief Disable pull-up / pull-down function */
#define IOPCTL_PIO_PUPD_EN 0x10u          /*!<@brief Enable pull-up / pull-down function */
#define IOPCTL_PIO_SLEW_RATE_NORMAL 0x00u /*!<@brief Normal mode */

/*! @name SD0_CARD_DET_N (coord R13), J32[10]/CARD_CD/SD_CD
  @{ */
/* Routed pin properties */
#define BOARD_INITUSDHCPINS_SD_CD_PERIPHERAL USDHC0             /*!<@brief Peripheral name */
#define BOARD_INITUSDHCPINS_SD_CD_SIGNAL USDHC_CD_B             /*!<@brief Signal name */
                                                                /* @} */

/*! @name SD0_CLK (coord P10), J32[5]/SD_CLK
  @{ */
/* Routed pin properties */
#define BOARD_INITUSDHCPINS_SD_CLK_PERIPHERAL USDHC0     /*!<@brief Peripheral name */
#define BOARD_INITUSDHCPINS_SD_CLK_SIGNAL USDHC_CLK      /*!<@brief Signal name */
                                                         /* @} */

/*! @name SD0_CMD (coord R9), J32[2]/SD_CMD
  @{ */
/* Routed pin properties */
#define BOARD_INITUSDHCPINS_SD_CMD_PERIPHERAL USDHC0     /*!<@brief Peripheral name */
#define BOARD_INITUSDHCPINS_SD_CMD_SIGNAL USDHC_CMD      /*!<@brief Signal name */
                                                         /* @} */

/*! @name SD0_D0 (coord R11), J32[7]/SD_DAT0
  @{ */
/* Routed pin properties */
#define BOARD_INITUSDHCPINS_SD_DAT0_PERIPHERAL USDHC0      /*!<@brief Peripheral name */
#define BOARD_INITUSDHCPINS_SD_DAT0_SIGNAL USDHC_DATA      /*!<@brief Signal name */
#define BOARD_INITUSDHCPINS_SD_DAT0_CHANNEL 0              /*!<@brief Signal channel */
                                                           /* @} */

/*! @name SD0_D1 (coord T11), J32[8]/SD_DAT1
  @{ */
/* Routed pin properties */
#define BOARD_INITUSDHCPINS_SD_DAT1_PERIPHERAL USDHC0      /*!<@brief Peripheral name */
#define BOARD_INITUSDHCPINS_SD_DAT1_SIGNAL USDHC_DATA      /*!<@brief Signal name */
#define BOARD_INITUSDHCPINS_SD_DAT1_CHANNEL 1              /*!<@brief Signal channel */
                                                           /* @} */

/*! @name SD0_D2 (coord U11), J32[9]/SD_DAT2
  @{ */
/* Routed pin properties */
#define BOARD_INITUSDHCPINS_SD_DAT2_PERIPHERAL USDHC0      /*!<@brief Peripheral name */
#define BOARD_INITUSDHCPINS_SD_DAT2_SIGNAL USDHC_DATA      /*!<@brief Signal name */
#define BOARD_INITUSDHCPINS_SD_DAT2_CHANNEL 2              /*!<@brief Signal channel */
                                                           /* @} */

/*! @name SD0_D3 (coord T12), J32[1]/SD_DAT3
  @{ */
/* Routed pin properties */
#define BOARD_INITUSDHCPINS_SD_DAT3_PERIPHERAL USDHC0      /*!<@brief Peripheral name */
#define BOARD_INITUSDHCPINS_SD_DAT3_SIGNAL USDHC_DATA      /*!<@brief Signal name */
#define BOARD_INITUSDHCPINS_SD_DAT3_CHANNEL 3              /*!<@brief Signal channel */
                                                           /* @} */

/*! @name PIO2_10 (coord T15), U23[3]/SD_RST_N
  @{ */
/* Routed pin properties */
#define BOARD_INITUSDHCPINS_SD_RST_N_PERIPHERAL GPIO           /*!<@brief Peripheral name */
#define BOARD_INITUSDHCPINS_SD_RST_N_SIGNAL PIO2               /*!<@brief Signal name */
#define BOARD_INITUSDHCPINS_SD_RST_N_CHANNEL 10                /*!<@brief Signal channel */

/* Symbols to be used with GPIO driver */
#define BOARD_INITUSDHCPINS_SD_RST_N_GPIO GPIO                 /*!<@brief GPIO peripheral base pointer */
#define BOARD_INITUSDHCPINS_SD_RST_N_GPIO_PIN_MASK (1U << 10U) /*!<@brief GPIO pin mask */
#define BOARD_INITUSDHCPINS_SD_RST_N_PORT 2U                   /*!<@brief PORT peripheral base pointer */
#define BOARD_INITUSDHCPINS_SD_RST_N_PIN 10U                   /*!<@brief PORT pin number */
#define BOARD_INITUSDHCPINS_SD_RST_N_PIN_MASK (1U << 10U)      /*!<@brief PORT pin mask */
                                                               /* @} */

/*! @name PIO2_4 (coord T13), J32[11]/CARD_WR_PRT/SD_WR_PRT
  @{ */
/* Routed pin properties */
/*!
 * @brief Peripheral name */
#define BOARD_INITUSDHCPINS_SD_WR_PRT_PERIPHERAL GPIO
/*!
 * @brief Signal name */
#define BOARD_INITUSDHCPINS_SD_WR_PRT_SIGNAL PIO2
/*!
 * @brief Signal channel */
#define BOARD_INITUSDHCPINS_SD_WR_PRT_CHANNEL 4

/* Symbols to be used with GPIO driver */
/*!
 * @brief GPIO peripheral base pointer */
#define BOARD_INITUSDHCPINS_SD_WR_PRT_GPIO GPIO
/*!
 * @brief GPIO pin mask */
#define BOARD_INITUSDHCPINS_SD_WR_PRT_GPIO_PIN_MASK (1U << 4U)
/*!
 * @brief PORT peripheral base pointer */
#define BOARD_INITUSDHCPINS_SD_WR_PRT_PORT 2U
/*!
 * @brief PORT pin number */
#define BOARD_INITUSDHCPINS_SD_WR_PRT_PIN 4U
/*!
 * @brief PORT pin mask */
#define BOARD_INITUSDHCPINS_SD_WR_PRT_PIN_MASK (1U << 4U)
/* @} */

/*!
 * @brief Configures pin routing and optionally pin electrical features.
 *
 */
void BOARD_InitUSDHCPins(void); /* Function assigned for the Cortex-M33 */

#define IOPCTL_PIO_ANAMUX_DI 0x00u        /*!<@brief Analog mux is disabled */
#define IOPCTL_PIO_FULLDRIVE_DI 0x00u     /*!<@brief Normal drive */
#define IOPCTL_PIO_FUNC1 0x01u            /*!<@brief Selects pin function 1 */
#define IOPCTL_PIO_INBUF_DI 0x00u         /*!<@brief Disable input buffer function */
#define IOPCTL_PIO_INBUF_EN 0x40u         /*!<@brief Enables input buffer function */
#define IOPCTL_PIO_INV_DI 0x00u           /*!<@brief Input function is not inverted */
#define IOPCTL_PIO_PSEDRAIN_DI 0x00u      /*!<@brief Pseudo Output Drain is disabled */
#define IOPCTL_PIO_PULLDOWN_EN 0x00u      /*!<@brief Enable pull-down function */
#define IOPCTL_PIO_PUPD_DI 0x00u          /*!<@brief Disable pull-up / pull-down function */
#define IOPCTL_PIO_SLEW_RATE_NORMAL 0x00u /*!<@brief Normal mode */

/*! @name FC4_CTS_SDA_SSEL0 (coord A11), Q4[2]
  @{ */
/* Routed pin properties */
#define BOARD_INITARDUINOUARTPINS_LED_RED_PERIPHERAL FLEXCOMM4       /*!<@brief Peripheral name */
#define BOARD_INITARDUINOUARTPINS_LED_RED_SIGNAL CTS_SDA_SSEL0       /*!<@brief Signal name */
                                                                     /* @} */

/*!
 * @brief Configures pin routing and optionally pin electrical features.
 *
 */
void BOARD_InitArduinoUARTPins(void); /* Function assigned for the Cortex-M33 */

#define IOPCTL_PIO_ANAMUX_DI 0x00u        /*!<@brief Analog mux is disabled */
#define IOPCTL_PIO_FULLDRIVE_EN 0x0100u   /*!<@brief Full drive enable */
#define IOPCTL_PIO_FUNC1 0x01u            /*!<@brief Selects pin function 1 */
#define IOPCTL_PIO_INBUF_DI 0x00u         /*!<@brief Disable input buffer function */
#define IOPCTL_PIO_INBUF_EN 0x40u         /*!<@brief Enables input buffer function */
#define IOPCTL_PIO_INV_DI 0x00u           /*!<@brief Input function is not inverted */
#define IOPCTL_PIO_PSEDRAIN_DI 0x00u      /*!<@brief Pseudo Output Drain is disabled */
#define IOPCTL_PIO_PULLDOWN_EN 0x00u      /*!<@brief Enable pull-down function */
#define IOPCTL_PIO_PUPD_DI 0x00u          /*!<@brief Disable pull-up / pull-down function */
#define IOPCTL_PIO_SLEW_RATE_NORMAL 0x00u /*!<@brief Normal mode */

/*!
 * @brief Configures pin routing and optionally pin electrical features.
 *
 */
void BOARD_Init_Audio_Pins(void); /* Function assigned for the Cortex-M33 */

#define IOPCTL_PIO_ANAMUX_DI 0x00u        /*!<@brief Analog mux is disabled */
#define IOPCTL_PIO_FULLDRIVE_DI 0x00u     /*!<@brief Normal drive */
#define IOPCTL_PIO_FULLDRIVE_EN 0x0100u   /*!<@brief Full drive enable */
#define IOPCTL_PIO_FUNC0 0x00u            /*!<@brief Selects pin function 0 */
#define IOPCTL_PIO_FUNC5 0x05u            /*!<@brief Selects pin function 5 */
#define IOPCTL_PIO_FUNC6 0x06u            /*!<@brief Selects pin function 6 */
#define IOPCTL_PIO_INBUF_DI 0x00u         /*!<@brief Disable input buffer function */
#define IOPCTL_PIO_INBUF_EN 0x40u         /*!<@brief Enables input buffer function */
#define IOPCTL_PIO_INV_DI 0x00u           /*!<@brief Input function is not inverted */
#define IOPCTL_PIO_PSEDRAIN_DI 0x00u      /*!<@brief Pseudo Output Drain is disabled */
#define IOPCTL_PIO_PULLDOWN_EN 0x00u      /*!<@brief Enable pull-down function */
#define IOPCTL_PIO_PUPD_DI 0x00u          /*!<@brief Disable pull-up / pull-down function */
#define IOPCTL_PIO_SLEW_RATE_NORMAL 0x00u /*!<@brief Normal mode */

/*! @name FLEXSPI0B_DATA0 (coord L2), U19[D3]
  @{ */
/* Routed pin properties */
#define BOARD_INITFLEXSPI0BPINS_QSPI_B_DATA0_PERIPHERAL FLEXSPI       /*!<@brief Peripheral name */
#define BOARD_INITFLEXSPI0BPINS_QSPI_B_DATA0_SIGNAL FLEXSPI_B_DATA0   /*!<@brief Signal name */
                                                                      /* @} */

/*! @name FLEXSPI0B_DATA1 (coord M2), U19[D2]
  @{ */
/* Routed pin properties */
#define BOARD_INITFLEXSPI0BPINS_QSPI_B_DATA1_PERIPHERAL FLEXSPI       /*!<@brief Peripheral name */
#define BOARD_INITFLEXSPI0BPINS_QSPI_B_DATA1_SIGNAL FLEXSPI_B_DATA1   /*!<@brief Signal name */
                                                                      /* @} */

/*! @name FLEXSPI0B_DATA2 (coord N1), U19[C4]
  @{ */
/* Routed pin properties */
#define BOARD_INITFLEXSPI0BPINS_QSPI_B_DATA2_PERIPHERAL FLEXSPI       /*!<@brief Peripheral name */
#define BOARD_INITFLEXSPI0BPINS_QSPI_B_DATA2_SIGNAL FLEXSPI_B_DATA2   /*!<@brief Signal name */
                                                                      /* @} */

/*! @name FLEXSPI0B_DATA3 (coord N2), U19[D4]
  @{ */
/* Routed pin properties */
#define BOARD_INITFLEXSPI0BPINS_QSPI_B_DATA3_PERIPHERAL FLEXSPI       /*!<@brief Peripheral name */
#define BOARD_INITFLEXSPI0BPINS_QSPI_B_DATA3_SIGNAL FLEXSPI_B_DATA3   /*!<@brief Signal name */
                                                                      /* @} */

/*! @name FLEXSPI0B_DATA4 (coord U1), U19[D5]
  @{ */
/* Routed pin properties */
#define BOARD_INITFLEXSPI0BPINS_QSPI_B_DATA4_PERIPHERAL FLEXSPI       /*!<@brief Peripheral name */
#define BOARD_INITFLEXSPI0BPINS_QSPI_B_DATA4_SIGNAL FLEXSPI_B_DATA4   /*!<@brief Signal name */
                                                                      /* @} */

/*! @name FLEXSPI0B_DATA5 (coord R2), U19[E3]
  @{ */
/* Routed pin properties */
#define BOARD_INITFLEXSPI0BPINS_QSPI_B_DATA5_PERIPHERAL FLEXSPI       /*!<@brief Peripheral name */
#define BOARD_INITFLEXSPI0BPINS_QSPI_B_DATA5_SIGNAL FLEXSPI_B_DATA5   /*!<@brief Signal name */
                                                                      /* @} */

/*! @name FLEXSPI0B_DATA6 (coord P3), U19[E2]
  @{ */
/* Routed pin properties */
#define BOARD_INITFLEXSPI0BPINS_QSPI_B_DATA6_PERIPHERAL FLEXSPI       /*!<@brief Peripheral name */
#define BOARD_INITFLEXSPI0BPINS_QSPI_B_DATA6_SIGNAL FLEXSPI_B_DATA6   /*!<@brief Signal name */
                                                                      /* @} */

/*! @name FLEXSPI0B_DATA7 (coord P5), U19[E1]
  @{ */
/* Routed pin properties */
#define BOARD_INITFLEXSPI0BPINS_QSPI_B_DATA7_PERIPHERAL FLEXSPI       /*!<@brief Peripheral name */
#define BOARD_INITFLEXSPI0BPINS_QSPI_B_DATA7_SIGNAL FLEXSPI_B_DATA7   /*!<@brief Signal name */
                                                                      /* @} */

/*! @name FLEXSPI0B_SCLK (coord U3), U19[B2]
  @{ */
/* Routed pin properties */
#define BOARD_INITFLEXSPI0BPINS_QSPI_B_SCK_PERIPHERAL FLEXSPI      /*!<@brief Peripheral name */
#define BOARD_INITFLEXSPI0BPINS_QSPI_B_SCK_SIGNAL FLEXSPI_B_SCLK   /*!<@brief Signal name */
                                                                   /* @} */

/*! @name FLEXSPI0B_SS0_N (coord T2), U19[C2]
  @{ */
/* Routed pin properties */
#define BOARD_INITFLEXSPI0BPINS_QSPI_B_CS0_PERIPHERAL FLEXSPI       /*!<@brief Peripheral name */
#define BOARD_INITFLEXSPI0BPINS_QSPI_B_CS0_SIGNAL FLEXSPI_B_SS0_B   /*!<@brief Signal name */
                                                                    /* @} */

/*!
 * @brief Configures pin routing and optionally pin electrical features.
 *
 */
void BOARD_InitFlexSPI0BPins(void); /* Function assigned for the Cortex-M33 */

#define IOPCTL_PIO_ANAMUX_DI 0x00u        /*!<@brief Analog mux is disabled */
#define IOPCTL_PIO_FULLDRIVE_EN 0x0100u   /*!<@brief Full drive enable */
#define IOPCTL_PIO_FUNC1 0x01u            /*!<@brief Selects pin function 1 */
#define IOPCTL_PIO_INBUF_EN 0x40u         /*!<@brief Enables input buffer function */
#define IOPCTL_PIO_INV_DI 0x00u           /*!<@brief Input function is not inverted */
#define IOPCTL_PIO_PSEDRAIN_DI 0x00u      /*!<@brief Pseudo Output Drain is disabled */
#define IOPCTL_PIO_PULLDOWN_EN 0x00u      /*!<@brief Enable pull-down function */
#define IOPCTL_PIO_PUPD_DI 0x00u          /*!<@brief Disable pull-up / pull-down function */
#define IOPCTL_PIO_SLEW_RATE_NORMAL 0x00u /*!<@brief Normal mode */

/*! @name FC5_RXD_SDA_MOSI_DATA (coord J16), J28[4]/JP30[1]/J45[22]
  @{ */
/* Routed pin properties */
#define BOARD_INITSCOPINS_ACC_INT_PERIPHERAL FLEXCOMM5           /*!<@brief Peripheral name */
#define BOARD_INITSCOPINS_ACC_INT_SIGNAL RXD_SDA_MOSI_DATA       /*!<@brief Signal name */
                                                                 /* @} */

/*!
 * @brief Configures pin routing and optionally pin electrical features.
 *
 */
void BOARD_InitScoPins(void); /* Function assigned for the Cortex-M33 */

#if defined(__cplusplus)
}
#endif

/*!
 * @}
 */
#endif /* _PIN_MUX_H_ */

/***********************************************************************************************************************
 * EOF
 **********************************************************************************************************************/
